#pragma once
#include <jni.h>

#include <string>
#include <map>

namespace Plugin {

class Event {
private:
	std::string name; //name of the event
	jobject input;    //original Event object (type CppEvent)
	std::map<std::string, void*> data;
public:
	virtual jobject getMap(JNIEnv* env);
	virtual const std::string& getName() const;
	virtual void* getData(JNIEnv* env, const std::string& name);
	virtual void setData(const std::string& name, void* data);

	virtual void reapply(JNIEnv* env, jobject jevent);

	Event(JNIEnv* env, jobject jevent);
	//virtual ~Event();
};

} //namespace Plugin
